from typing import List, Optional
from axelrod.action import Action
from axelrod.player import Player
lIIIIllIlIIIlllII = List[float]
IIlIIIlIIIlIllIl, lllllIIlIlIIl = Action.C, Action.D
class IlIllllIllllllII(Player):
    llIIIIlIlIIlllIlIl = "strategy"
    IIIIIlIlIlllIIlIlllI = {
        "stochastic": False,
        "memory_depth": float("inf"),  
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def lIlllIIIlllIlI(IIIIIIIIlIlIl, llIllllIIlIIl: Player) -> Action:
        llIIlIllllIIIlllIl = len(IIIIIIIIlIlIl.history)
        if llIIlIllllIIIlllIl == 0:
            return lllllIIlIlIIl
        if llIIlIllllIIIlllIl == 1:
            return IIlIIIlIIIlIllIl
        if llIIlIllllIIIlllIl > 1:
            if llIllllIIlIIl.history[1] == IIlIIIlIIIlIllIl:
                return lllllIIlIlIIl
            else:
                return lllllIIlIlIIl if llIllllIIlIIl.history[-1:] == [lllllIIlIlIIl] else IIlIIIlIIIlIllIl